/*!
 * react-md-parser v1.0.0
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["markdown"] = factory(require("react"));
	else
		root["markdown"] = factory(root["React"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

var rng = __webpack_require__(3);
var bytesToUuid = __webpack_require__(4);

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof(options) == 'string') {
    buf = options === 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rng)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = (rnds[6] & 0x0f) | 0x40;
  rnds[8] = (rnds[8] & 0x3f) | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid(rnds);
}

module.exports = v4;


/***/ }),
/* 3 */
/***/ (function(module, exports) {

// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection

// getRandomValues needs to be invoked in a context where "this" is a Crypto
// implementation. Also, find the complete implementation of crypto on IE11.
var getRandomValues = (typeof(crypto) != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto)) ||
                      (typeof(msCrypto) != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto));

if (getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef

  module.exports = function whatwgRNG() {
    getRandomValues(rnds8);
    return rnds8;
  };
} else {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);

  module.exports = function mathRNG() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}


/***/ }),
/* 4 */
/***/ (function(module, exports) {

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  // join used to fix memory issue caused by concatenation: https://bugs.chromium.org/p/v8/issues/detail?id=3175#c4
  return ([bth[buf[i++]], bth[buf[i++]], 
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]],
	bth[buf[i++]], bth[buf[i++]],
	bth[buf[i++]], bth[buf[i++]]]).join('');
}

module.exports = bytesToUuid;


/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external {"root":"React","commonjs2":"react","commonjs":"react","amd":"react"}
var external_root_React_commonjs2_react_commonjs_react_amd_react_ = __webpack_require__(0);
var external_root_React_commonjs2_react_commonjs_react_amd_react_default = /*#__PURE__*/__webpack_require__.n(external_root_React_commonjs2_react_commonjs_react_amd_react_);

// CONCATENATED MODULE: ./src/MarkdownConfig.js
var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MarkdownConfig = (_temp = _class = function MarkdownConfig() {
	_classCallCheck(this, MarkdownConfig);
}, _class.BlockParsers = [], _class.InlineParsers = [], _class.Renders = {}, _class.haveInited = false, _temp);


/* harmony default export */ var src_MarkdownConfig = (MarkdownConfig);
// CONCATENATED MODULE: ./src/MarkdownRender.js
var MarkdownRender_class, MarkdownRender_temp;

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function MarkdownRender_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }




var MarkdownRender_MarkdownRender = function () {
	function MarkdownRender() {
		MarkdownRender_classCallCheck(this, MarkdownRender);
	}

	MarkdownRender.init = function init() {
		src_MarkdownConfig.Renders = {
			h: MarkdownRender_H,
			p: MarkdownRender_P,
			br: MarkdownRender_Br,
			ul: MarkdownRender_UList,
			ol: MarkdownRender_OList,
			quote: MarkdownRender_Quote,
			link: MarkdownRender_Link,
			image: MarkdownRender_Image,
			em: MarkdownRender_Em,
			strong: MarkdownRender_Strong,
			code: MarkdownRender_Code
		};
	};

	return MarkdownRender;
}();

var MarkdownRender_H = (MarkdownRender_temp = MarkdownRender_class = function (_Component) {
	_inherits(H, _Component);

	function H() {
		MarkdownRender_classCallCheck(this, H);

		return _possibleConstructorReturn(this, _Component.apply(this, arguments));
	}

	H.prototype.render = function render() {
		var level = this.props.level;
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement('h' + level, null, this.props.children);
	};

	return H;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]), MarkdownRender_class.defaultProps = {
	level: 1
}, MarkdownRender_temp);

var MarkdownRender_P = function (_Component2) {
	_inherits(P, _Component2);

	function P() {
		MarkdownRender_classCallCheck(this, P);

		return _possibleConstructorReturn(this, _Component2.apply(this, arguments));
	}

	P.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'p',
			null,
			this.props.children
		);
	};

	return P;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Br = function (_Component3) {
	_inherits(Br, _Component3);

	function Br() {
		MarkdownRender_classCallCheck(this, Br);

		return _possibleConstructorReturn(this, _Component3.apply(this, arguments));
	}

	Br.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement('br', null);
	};

	return Br;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_UList = function (_Component4) {
	_inherits(UList, _Component4);

	function UList() {
		MarkdownRender_classCallCheck(this, UList);

		return _possibleConstructorReturn(this, _Component4.apply(this, arguments));
	}

	UList.prototype.render = function render() {
		var list = this.props.list;
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'ul',
			null,
			list.map(function (it) {
				return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					'li',
					null,
					it
				);
			})
		);
	};

	return UList;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_OList = function (_Component5) {
	_inherits(OList, _Component5);

	function OList() {
		MarkdownRender_classCallCheck(this, OList);

		return _possibleConstructorReturn(this, _Component5.apply(this, arguments));
	}

	OList.prototype.render = function render() {
		var list = this.props.list;
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'ol',
			null,
			list.map(function (it) {
				return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					'li',
					null,
					it
				);
			})
		);
	};

	return OList;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Quote = function (_Component6) {
	_inherits(Quote, _Component6);

	function Quote() {
		MarkdownRender_classCallCheck(this, Quote);

		return _possibleConstructorReturn(this, _Component6.apply(this, arguments));
	}

	Quote.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'blockquote',
			null,
			this.props.children
		);
	};

	return Quote;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Link = function (_Component7) {
	_inherits(Link, _Component7);

	function Link() {
		MarkdownRender_classCallCheck(this, Link);

		return _possibleConstructorReturn(this, _Component7.apply(this, arguments));
	}

	Link.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'a',
			{ href: this.props.to, title: this.props.title },
			this.props.children
		);
	};

	return Link;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Image = function (_Component8) {
	_inherits(Image, _Component8);

	function Image() {
		MarkdownRender_classCallCheck(this, Image);

		return _possibleConstructorReturn(this, _Component8.apply(this, arguments));
	}

	Image.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement('img', { src: this.props.src, alt: this.props.alt });
	};

	return Image;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Em = function (_Component9) {
	_inherits(Em, _Component9);

	function Em() {
		MarkdownRender_classCallCheck(this, Em);

		return _possibleConstructorReturn(this, _Component9.apply(this, arguments));
	}

	Em.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'em',
			null,
			this.props.children
		);
	};

	return Em;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Strong = function (_Component10) {
	_inherits(Strong, _Component10);

	function Strong() {
		MarkdownRender_classCallCheck(this, Strong);

		return _possibleConstructorReturn(this, _Component10.apply(this, arguments));
	}

	Strong.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'strong',
			null,
			this.props.children
		);
	};

	return Strong;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

var MarkdownRender_Code = function (_Component11) {
	_inherits(Code, _Component11);

	function Code() {
		MarkdownRender_classCallCheck(this, Code);

		return _possibleConstructorReturn(this, _Component11.apply(this, arguments));
	}

	Code.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			'code',
			null,
			this.props.children
		);
	};

	return Code;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);


// CONCATENATED MODULE: ./src/MarkdownParser.js
var _class7, _temp3;

function MarkdownParser_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function MarkdownParser_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function MarkdownParser_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }





var _uuid = __webpack_require__(2);

var Parser = function () {
	Parser.prototype.toString = function toString() {
		return this.name;
	};

	function Parser() {
		MarkdownParser_classCallCheck(this, Parser);

		this.name = 'Parser';
	}

	Parser.prototype.render = function render() {
		return null;
	};

	return Parser;
}();

var MarkdownParser_BlockParser = function (_Parser) {
	MarkdownParser_inherits(BlockParser, _Parser);

	function BlockParser() {
		MarkdownParser_classCallCheck(this, BlockParser);

		var _this = MarkdownParser_possibleConstructorReturn(this, _Parser.call(this));

		_this.inline_tree = [];
		_this.comps = {};
		_this.name = 'BlockParser';
		_this.md = null;
		_this.inlines = [MarkdownParser_CodeInline, MarkdownParser_ImageInline, MarkdownParser_LinkInline, MarkdownParser_StrongInline, MarkdownParser_EmInline];
		return _this;
	}

	BlockParser.prototype.bindMarkdown = function bindMarkdown(md) {
		this.md = md;
	};

	BlockParser.prototype.bindComp = function bindComp(uuid, inline) {
		this.comps[uuid] = inline;
	};

	BlockParser.prototype.add = function add(inline) {
		this.inline_tree.push(this.parseInline(inline));
	};

	BlockParser.prototype.parseInline = function parseInline(line) {
		var ret = line;
		for (var _iterator = src_MarkdownConfig.InlineParsers, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
			var _ref;

			if (_isArray) {
				if (_i >= _iterator.length) break;
				_ref = _iterator[_i++];
			} else {
				_i = _iterator.next();
				if (_i.done) break;
				_ref = _i.value;
			}

			var inline = _ref;

			if (inline.test(ret)) {
				ret = inline.parse(ret, this);
			}
		}
		return ret;
	};

	BlockParser.prototype.renderInline = function renderInline() {
		var result = [];
		for (var _iterator2 = this.inline_tree, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
			var _ref2;

			if (_isArray2) {
				if (_i2 >= _iterator2.length) break;
				_ref2 = _iterator2[_i2++];
			} else {
				_i2 = _iterator2.next();
				if (_i2.done) break;
				_ref2 = _i2.value;
			}

			var line = _ref2;

			result.push(InlineParser.renderChildren(line, this.md, this.comps));
		}
		return result;
	};

	return BlockParser;
}(Parser);

var InlineParser = function (_Parser2) {
	MarkdownParser_inherits(InlineParser, _Parser2);

	function InlineParser() {
		MarkdownParser_classCallCheck(this, InlineParser);

		var _this2 = MarkdownParser_possibleConstructorReturn(this, _Parser2.call(this));

		_this2.name = 'InlineParser';
		return _this2;
	}

	InlineParser.getPattern = function getPattern() {
		return (/@/
		);
	};

	InlineParser.getUUID = function getUUID() {
		return '{$@' + _uuid().replace(/\-/g, '') + '}';
	};

	InlineParser.parseOne = function parseOne(line, block) {
		return line;
	};

	InlineParser.parse = function parse(line, block) {
		var tmp = line;
		var index = tmp.search(this.getPattern());
		while (index != -1) {
			tmp = this.parseOne(tmp, block);
			index = tmp.search(this.getPattern());
		}
		return tmp;
	};

	InlineParser.renderChildren = function renderChildren(line, md, comps) {
		var result = [];
		var parts = line.split('{@SPLIT@}');
		for (var _iterator3 = parts, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
			var _ref3;

			if (_isArray3) {
				if (_i3 >= _iterator3.length) break;
				_ref3 = _iterator3[_i3++];
			} else {
				_i3 = _iterator3.next();
				if (_i3.done) break;
				_ref3 = _i3.value;
			}

			var part = _ref3;

			if (part.match(/^\{\$@.*\}$/)) {
				result.push(comps[part].render(md, comps));
			} else {
				result.push(part);
			}
		}
		return result;
	};

	return InlineParser;
}(Parser);

var MarkdownParser_HBlock = function (_BlockParser) {
	MarkdownParser_inherits(HBlock, _BlockParser);

	function HBlock() {
		MarkdownParser_classCallCheck(this, HBlock);

		var _this3 = MarkdownParser_possibleConstructorReturn(this, _BlockParser.call(this));

		_this3.level = 1;
		return _this3;
	}

	HBlock.test = function test(line) {
		return (/^#+ .+/.test(line)
		);
	};

	HBlock.parse = function parse(line, lastBlock) {
		var block = new HBlock();
		block.level = line.match(/^#+/)[0].length;
		var l = line.replace(/^#+ /, '').replace(/\s*#*$/, '');
		block.add(l);
		return block;
	};

	HBlock.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_H,
			{ level: this.level },
			this.renderInline()
		);
	};

	return HBlock;
}(MarkdownParser_BlockParser);

var MarkdownParser_PBlock = function (_BlockParser2) {
	MarkdownParser_inherits(PBlock, _BlockParser2);

	function PBlock() {
		MarkdownParser_classCallCheck(this, PBlock);

		return MarkdownParser_possibleConstructorReturn(this, _BlockParser2.call(this));
	}

	PBlock.test = function test(line) {
		return true;
	};

	PBlock.parse = function parse(line, lastBlock) {
		if (lastBlock instanceof PBlock) {
			lastBlock.add(line);
			return null;
		}
		var block = new PBlock();
		block.add(line);
		return block;
	};

	PBlock.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_P,
			null,
			this.renderInline()
		);
	};

	return PBlock;
}(MarkdownParser_BlockParser);

var MarkdownParser_UListBlock = function (_BlockParser3) {
	MarkdownParser_inherits(UListBlock, _BlockParser3);

	function UListBlock() {
		MarkdownParser_classCallCheck(this, UListBlock);

		return MarkdownParser_possibleConstructorReturn(this, _BlockParser3.call(this));
	}

	UListBlock.test = function test(line) {
		return (/^[\*\+\-] /.test(line)
		);
	};

	UListBlock.parse = function parse(line, lastBlock) {
		var l = line.replace(/^[\*\+\-] /, '');
		if (lastBlock instanceof UListBlock) {
			lastBlock.add(l);
			return null;
		}
		var block = new UListBlock();
		block.add(l);
		return block;
	};

	UListBlock.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(MarkdownRender_UList, { list: this.renderInline() });
	};

	return UListBlock;
}(MarkdownParser_BlockParser);

var MarkdownParser_OListBlock = function (_BlockParser4) {
	MarkdownParser_inherits(OListBlock, _BlockParser4);

	function OListBlock() {
		MarkdownParser_classCallCheck(this, OListBlock);

		return MarkdownParser_possibleConstructorReturn(this, _BlockParser4.call(this));
	}

	OListBlock.test = function test(line) {
		return (/^\d+\. /.test(line)
		);
	};

	OListBlock.parse = function parse(line, lastBlock) {
		var l = line.replace(/^\d+\. /, '');
		if (lastBlock instanceof OListBlock) {
			lastBlock.add(l);
			return null;
		}
		var block = new OListBlock();
		block.add(l);
		return block;
	};

	OListBlock.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(MarkdownRender_OList, { list: this.renderInline() });
	};

	return OListBlock;
}(MarkdownParser_BlockParser);

var MarkdownParser_QuoteBlock = function (_BlockParser5) {
	MarkdownParser_inherits(QuoteBlock, _BlockParser5);

	function QuoteBlock() {
		MarkdownParser_classCallCheck(this, QuoteBlock);

		return MarkdownParser_possibleConstructorReturn(this, _BlockParser5.call(this));
	}

	QuoteBlock.test = function test(line) {
		return (/^>/.test(line)
		);
	};

	QuoteBlock.parse = function parse(line, lastBlock) {
		var l = line.replace(/^>/, '');
		if (lastBlock instanceof QuoteBlock) {
			lastBlock.text += '\n' + l;
			return null;
		}
		var block = new QuoteBlock();
		block.text = l;
		return block;
	};

	QuoteBlock.prototype.render = function render() {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_Quote,
			null,
			new MarkdownParser_MarkdownParser().parse(this.text)
		);
	};

	return QuoteBlock;
}(MarkdownParser_BlockParser);

var RefBlock = function (_BlockParser6) {
	MarkdownParser_inherits(RefBlock, _BlockParser6);

	function RefBlock() {
		MarkdownParser_classCallCheck(this, RefBlock);

		return MarkdownParser_possibleConstructorReturn(this, _BlockParser6.call(this));
	}

	RefBlock.test = function test(line) {
		return (/^\[.*\]:\s+.*/.test(line)
		);
	};

	RefBlock.parse = function parse(line, lastBlock, parser) {
		var block = new RefBlock();
		block.id = line.match(/^\[.*\]/)[0].replace(/[\[\]]/g, '');
		if (/[\)\'\"]$/.test(line)) {
			block.title = line.match(/[\(\'\"].*[\)\'\"]$/)[0].replace(/[\(\)\'\"]/g, '');
			line = line.replace(/\s*[\(\'\"].*[\)\'\"]$/, '');
		} else {
			block.title = '';
		}
		block.link = line.match(/:\s+.*$/)[0].replace(/^:\s+/, '');
		parser.addRef(block);
		return null;
	};

	RefBlock.prototype.render = function render() {
		return null;
	};

	return RefBlock;
}(MarkdownParser_BlockParser);

var MarkdownParser_LinkInline = function (_InlineParser) {
	MarkdownParser_inherits(LinkInline, _InlineParser);

	function LinkInline() {
		var _temp, _this9, _ret;

		MarkdownParser_classCallCheck(this, LinkInline);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this9 = MarkdownParser_possibleConstructorReturn(this, _InlineParser.call.apply(_InlineParser, [this].concat(args))), _this9), _this9.name = 'LinkInline', _temp), MarkdownParser_possibleConstructorReturn(_this9, _ret);
	}

	LinkInline.test = function test(line) {
		return (/\[.*?\](\(.*?\)|\s?\[.*?\])/.test(line)
		);
	};

	LinkInline.getPattern = function getPattern() {
		return (/\[.*?\](\(.*?\)|\s?\[.*?\])/
		);
	};

	LinkInline.parseOne = function parseOne(line, block) {
		var tmp = line;
		var inline = new LinkInline();
		var match = tmp.match(this.getPattern())[0];
		inline.text = match.match(/\[.*?\]/)[0].replace(/[\[\]]/g, '');
		if (/\[.*?\]\s?\[.*?\]$/.test(match)) {
			inline.ref = match.substr(match.match(/\[.*?\]/)[0].length).match(/\[.*\]$/)[0].replace(/[\[\]]/g, '');
		} else {
			inline.link = match.match(/\(.*?\)/)[0].replace(/[\(\)]/g, '');
			if (/ [\'\"].*[\'\"]$/.test(inline.link)) {
				inline.title = inline.link.match(/ [\'\"].*[\'\"]$/)[0].replace(/[ \'\"]/, '');
				inline.link = inline.link.replace(/ [\'\"].*[\'\"]$/, '');
			} else {
				inline.title = '';
			}
		}
		var uuid = this.getUUID();
		block.bindComp(uuid, inline);
		return tmp.replace(this.getPattern(), '{@SPLIT@}' + uuid + '{@SPLIT@}');
	};

	LinkInline.prototype.render = function render(md, comps) {
		if (this.ref != undefined & md.refs[this.ref] != undefined) {
			this.link = md.refs[this.ref].link;
			this.title = md.refs[this.ref].title;
		}
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_Link,
			{ to: this.link, title: this.title },
			InlineParser.renderChildren(this.text, md, comps)
		);
	};

	return LinkInline;
}(InlineParser);

var MarkdownParser_ImageInline = function (_InlineParser2) {
	MarkdownParser_inherits(ImageInline, _InlineParser2);

	function ImageInline() {
		var _temp2, _this10, _ret2;

		MarkdownParser_classCallCheck(this, ImageInline);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this10 = MarkdownParser_possibleConstructorReturn(this, _InlineParser2.call.apply(_InlineParser2, [this].concat(args))), _this10), _this10.name = 'ImageInline', _temp2), MarkdownParser_possibleConstructorReturn(_this10, _ret2);
	}

	ImageInline.test = function test(line) {
		return (/\!\[.*?\](\(.*?\)|\s?\[.*?\])/.test(line)
		);
	};

	ImageInline.getPattern = function getPattern() {
		return (/\!\[.*?\](\(.*?\)|\s?\[.*?\])/
		);
	};

	ImageInline.parseOne = function parseOne(line, block) {
		var tmp = line;
		var inline = new ImageInline();
		var match = tmp.match(this.getPattern())[0];
		inline.alt = match.match(/\!\[.*?\]/)[0].replace(/[\!\[\]]/g, '');
		if (/\!\[.*?\]\s?\[.*?\]/.test(match)) {
			inline.ref = match.substr(match.match(/\!\[.*?\]/)[0].length).match(/\[.*\]$/)[0].replace(/[\[\]]/g, '');
		} else {
			inline.src = match.match(/\(.*?\)/)[0].replace(/[\(\)]/g, '');
		}
		var uuid = this.getUUID();
		block.bindComp(uuid, inline);
		return tmp.replace(this.getPattern(), '{@SPLIT@}' + uuid + '{@SPLIT@}');
	};

	ImageInline.prototype.render = function render(md, comps) {
		if (this.ref != undefined) {
			this.src = md.refs[this.ref].link;
			this.alt = md.refs[this.ref].title;
		}
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(MarkdownRender_Image, { src: this.src, alt: this.alt });
	};

	return ImageInline;
}(InlineParser);

var MarkdownParser_EmInline = function (_InlineParser3) {
	MarkdownParser_inherits(EmInline, _InlineParser3);

	function EmInline() {
		MarkdownParser_classCallCheck(this, EmInline);

		return MarkdownParser_possibleConstructorReturn(this, _InlineParser3.apply(this, arguments));
	}

	EmInline.test = function test(line) {
		return (/(\*|\_)[^\*\_]*?(\*|\_)/.test(line)
		);
	};

	EmInline.getPattern = function getPattern() {
		return (/(\*|\_)[^\*\_]*?(\*|\_)/
		);
	};

	EmInline.parseOne = function parseOne(line, block) {
		var tmp = line;
		var inline = new EmInline();
		var match = tmp.match(this.getPattern())[0];
		inline.text = match.replace(/[\*\_]/g, '');
		var uuid = this.getUUID();
		block.bindComp(uuid, inline);
		return tmp.replace(this.getPattern(), '{@SPLIT@}' + uuid + '{@SPLIT@}');
	};

	EmInline.prototype.render = function render(md, comps) {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_Em,
			null,
			InlineParser.renderChildren(this.text, md, comps)
		);
	};

	return EmInline;
}(InlineParser);

var MarkdownParser_StrongInline = function (_InlineParser4) {
	MarkdownParser_inherits(StrongInline, _InlineParser4);

	function StrongInline() {
		MarkdownParser_classCallCheck(this, StrongInline);

		return MarkdownParser_possibleConstructorReturn(this, _InlineParser4.apply(this, arguments));
	}

	StrongInline.test = function test(line) {
		return (/(\*\*|\_\_)[^\*\_]*?(\*\*|\_\_)/.test(line)
		);
	};

	StrongInline.getPattern = function getPattern() {
		return (/(\*\*|\_\_)[^\*\_]*?(\*\*|\_\_)/
		);
	};

	StrongInline.parseOne = function parseOne(line, block) {
		var tmp = line;
		var inline = new StrongInline();
		var match = tmp.match(this.getPattern())[0];
		inline.text = match.replace(/[\*\_]/g, '');
		var uuid = this.getUUID();
		block.bindComp(uuid, inline);
		return tmp.replace(this.getPattern(), '{@SPLIT@}' + uuid + '{@SPLIT@}');
	};

	StrongInline.prototype.render = function render(md, comps) {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			src_MarkdownConfig.Renders.strong,
			null,
			InlineParser.renderChildren(this.text, md, comps)
		);
	};

	return StrongInline;
}(InlineParser);

var MarkdownParser_CodeInline = function (_InlineParser5) {
	MarkdownParser_inherits(CodeInline, _InlineParser5);

	function CodeInline() {
		MarkdownParser_classCallCheck(this, CodeInline);

		return MarkdownParser_possibleConstructorReturn(this, _InlineParser5.apply(this, arguments));
	}

	CodeInline.test = function test(line) {
		return (/`.*?`/.test(line)
		);
	};

	CodeInline.getPattern = function getPattern() {
		return (/`.*?`/
		);
	};

	CodeInline.parseOne = function parseOne(line, block) {
		var tmp = line;
		var inline = new CodeInline();
		var match = tmp.match(this.getPattern())[0];
		inline.text = match.replace(/`/g, '');
		var uuid = this.getUUID();
		block.bindComp(uuid, inline);
		return tmp.replace(this.getPattern(), '{@SPLIT@}' + uuid + '{@SPLIT@}');
	};

	CodeInline.prototype.render = function render(md, comps) {
		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			MarkdownRender_Code,
			null,
			InlineParser.renderChildren(this.text, md, comps)
		);
	};

	return CodeInline;
}(InlineParser);

var MarkdownParser_MarkdownParser = (_temp3 = _class7 = function () {
	MarkdownParser.init = function init() {
		src_MarkdownConfig.BlockParsers = [MarkdownParser_QuoteBlock, RefBlock, MarkdownParser_HBlock, MarkdownParser_UListBlock, MarkdownParser_OListBlock, MarkdownParser_PBlock];
		src_MarkdownConfig.InlineParsers = [MarkdownParser_CodeInline, MarkdownParser_ImageInline, MarkdownParser_LinkInline, MarkdownParser_StrongInline, MarkdownParser_EmInline];
		MarkdownRender_MarkdownRender.init();
		src_MarkdownConfig.haveInited = true;
	};

	function MarkdownParser() {
		MarkdownParser_classCallCheck(this, MarkdownParser);

		this.block_tree = [];
		this.refs = {};
	}

	MarkdownParser.prototype.parse = function parse(source) {
		if (!src_MarkdownConfig.haveInited) {
			MarkdownParser.init();
		}
		var lines = source.split('\n');
		var lastBlock = null;
		this.block_tree = [];
		for (var _iterator4 = lines, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
			var _ref4;

			if (_isArray4) {
				if (_i4 >= _iterator4.length) break;
				_ref4 = _iterator4[_i4++];
			} else {
				_i4 = _iterator4.next();
				if (_i4.done) break;
				_ref4 = _i4.value;
			}

			var line = _ref4;

			for (var _iterator6 = src_MarkdownConfig.BlockParsers, _isArray6 = Array.isArray(_iterator6), _i6 = 0, _iterator6 = _isArray6 ? _iterator6 : _iterator6[Symbol.iterator]();;) {
				var _ref6;

				if (_isArray6) {
					if (_i6 >= _iterator6.length) break;
					_ref6 = _iterator6[_i6++];
				} else {
					_i6 = _iterator6.next();
					if (_i6.done) break;
					_ref6 = _i6.value;
				}

				var _block = _ref6;

				if (_block.test(line)) {
					var tmp = _block.parse(line, lastBlock, this);
					if (tmp != null) {
						lastBlock = tmp;
						lastBlock.bindMarkdown(this);
						this.block_tree.push(lastBlock);
					}
					break;
				}
			}
		}
		var result = [];
		for (var _iterator5 = this.block_tree, _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
			var _ref5;

			if (_isArray5) {
				if (_i5 >= _iterator5.length) break;
				_ref5 = _iterator5[_i5++];
			} else {
				_i5 = _iterator5.next();
				if (_i5.done) break;
				_ref5 = _i5.value;
			}

			var block = _ref5;

			result.push(block.render());
		}
		return result;
	};

	MarkdownParser.prototype.addRef = function addRef(block) {
		this.refs[block.id] = {
			link: block.link,
			title: block.title
		};
	};

	return MarkdownParser;
}(), _class7.blocks = [MarkdownParser_QuoteBlock, RefBlock, MarkdownParser_HBlock, MarkdownParser_UListBlock, MarkdownParser_OListBlock, MarkdownParser_PBlock], _temp3);


/* harmony default export */ var src_MarkdownParser = (MarkdownParser_MarkdownParser);
// CONCATENATED MODULE: ./src/index.js
function src_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function src_possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function src_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var src_Markdown = function (_Component) {
	src_inherits(Markdown, _Component);

	function Markdown() {
		src_classCallCheck(this, Markdown);

		return src_possibleConstructorReturn(this, _Component.apply(this, arguments));
	}

	Markdown.prototype.render = function render() {
		var mdp = new src_MarkdownParser();
		return mdp.parse(this.props.src);
	};

	return Markdown;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_["Component"]);

/* harmony default export */ var src = __webpack_exports__["default"] = (src_Markdown);

/***/ })
/******/ ])["default"];
});